﻿package
{
	import flash.display.MovieClip;
	import 	flash.geom.Point ;
	import Routeur;
	import PointControle;
	import TronconDroit;
	import Slot;

	public class Chemin extends MovieClip
	{
	 	var mPointControle:Array;
		var mBegin:Routeur;
		var mEnd:Routeur;

		var paquets:Array; 
		var emetteurs:Array;
		var parcours:Array;
		var xSuivs:Array;
		var ySuivs:Array;
		var toRemove:Array;
		var bruit:Boolean;
		var bruits:Array;

		public var mSlot1:int;
		public var mSlot2:int;
		
		var mCollision:Boolean;
	
		public function Chemin(_begin:Routeur, _end:Routeur, _collision:Boolean)
		{
			mPointControle = new Array();
			mBegin = _begin;
			mEnd = _end;
			paquets = new Array();
			emetteurs = new Array();
			parcours = new Array();
			xSuivs = new Array();
			ySuivs = new Array();
			toRemove = new Array();
			bruits = new Array();
			
			var p:Point = new Point(mBegin.casex, mBegin.casey);
			mPointControle.push(p);
			bruit = false;
			
			mCollision = _collision;
		}
		
		public function setBruit(bruitPresent:Boolean)
		{

			//pour chaque point de controle
			//placer l'effet de bruit
			if (bruit && (!bruitPresent) )
			{
				//trace("fin bruits!");
				for (var n1:int = 0 ; n1 < bruits.length; n1++) 
				{
					bruits[n1].visible = false;
				}
			}
			if ((!bruit) && bruitPresent)
			{
				//trace("bruits!");
				for (var n2:int = 0 ; n2 < bruits.length; n2++) 
				{
					bruits[n2].visible = true;
				}
			}
			bruit = bruitPresent;
				
		}
		
		public function addPointControle(_casex:int, _casey:int)
		{
			mPointControle.push(new Point(_casex, _casey));
		}
		
		public function setBeginSlot(_slot:int)
		{
			mSlot1 = _slot;
		}
		
		public function setEndSlot(_slot:int)
		{
			mSlot2 = _slot;
		}
		
		public function buildPath()
		{
			var pc:PointControle;
			
			var dx:int = 0;
			var dy:int = 0;
			
			// Ajoute l'arrivée
			var p:Point = new Point(mEnd.casex, mEnd.casey);
			mPointControle.push(p);
			
			var mPointControleCopy:Array = copy(mPointControle);
			
			// En utilisant les pop on part de la fin
			var _courant:Point = mPointControleCopy.pop();
			var _suivant:Point = mPointControleCopy.pop();
			
			var courant:Point = new Point(_courant.x, _courant.y);
			var suivant:Point = new Point(_suivant.x, _suivant.y);
			
			var olddx:int;
			var olddy:int;
			
			// Tant que le courant n'est pas le début ( le dernier ) on continue
			while(! (courant.x == mBegin.casex && courant.y == mBegin.casey))
			{
				olddx = dx;
				olddy = dy;
				var b:Bruit;
				
				// Si le courant et suivant sont au même endroit ou non alignés sur un axe alors il y a un probleme
				if((courant.x == suivant.x && courant.y == suivant.y) ||(courant.x != suivant.x && courant.y != suivant.y))
				{
					trace("Erreur d'alignement des points de controle : " + courant.x + " " + courant.y + " " + suivant.x + " " + suivant.y);
					break;
				}
				else
				{
					// Alignés en y
					if(courant.x == suivant.x)
					{
						if(courant.y < suivant.y) dy = 1; else dy = -1;
						dx = 0;
					}
					
					// Alignés en x
					if(courant.y == suivant.y)
					{
						if(courant.x < suivant.x) dx = 1; else dx = -1;
						dy = 0;
					}
				}
				

				
				if(olddx != 0 || olddy != 0)
				{
					if(olddx != 0 && olddy == 0)
					{
						if(olddx < 0)
						{
							if(dx < 0 && dy == 0)
							{
								// ok
								pc = new TronconDroit(courant.x, courant.y, true);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
							
							if(dx > 0 && dy == 0)
							{
								// ok
								pc = new TronconDroit(courant.x, courant.y, true);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
							
							if(dx == 0 && dy < 0)
							{
								// ok
								pc = new TronconCoude(courant.x, courant.y, 1);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
							
							if(dx == 0 && dy > 0)
							{
								// ok
								pc = new TronconCoude(courant.x, courant.y, 2);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
						}
						
						if(olddx > 0)
						{
							if(dx < 0 && dy == 0)
							{
								// ok
								pc = new TronconDroit(courant.x, courant.y, true);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
							
							if(dx > 0 && dy == 0)
							{
								// ok
								pc = new TronconDroit(courant.x, courant.y, true);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
							
							if(dx == 0 && dy < 0)
							{
								// ok
								pc = new TronconCoude(courant.x, courant.y, 0);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
							
							if(dx == 0 && dy > 0)
							{
								// ok
								pc = new TronconCoude(courant.x, courant.y, 3);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
						}
					}
					
					if(olddx == 0 && olddy != 0)
					{
						if(olddy < 0)
						{
							if(dx < 0 && dy == 0)
							{
								// ok
								pc = new TronconCoude(courant.x, courant.y, 3);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
							
							if(dx > 0 && dy == 0)
							{
								// ok
								pc = new TronconCoude(courant.x, courant.y, 2);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
							
							if(dx == 0 && dy < 0)
							{
								// ok
								pc = new TronconDroit(courant.x, courant.y, false);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
							
							if(dx == 0 && dy > 0)
							{
								// ok
								pc = new TronconDroit(courant.x, courant.y, false);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
						}
						
						if(olddy > 0)
						{
							if(dx < 0 && dy == 0)
							{
								// ok
								pc = new TronconCoude(courant.x, courant.y, 0);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
							
							if(dx > 0 && dy == 0)
							{
								// ok
								pc = new TronconCoude(courant.x, courant.y, 1);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
							
							if(dx == 0 && dy < 0)
							{
								// ok
								pc = new TronconDroit(courant.x, courant.y, false);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
							
							if(dx == 0 && dy > 0)
							{
								// ok
								pc = new TronconDroit(courant.x, courant.y, false);
								this.addChild(pc);
								b = new Bruit(courant.x, courant.y);
								b.visible = false;
								bruits.push(b);
								this.addChild(b);
							}
						}
					}
				}
								
				// Tant qu'on n'a pas atteind le point de controle suivant
				while(!(courant.x == suivant.x && courant.y == suivant.y))
				{
			
					// Si on n'est pas à coté du but
					if(! ( courant.x + dx == suivant.x && courant.y + dy == suivant.y))
					{ // on pose un tronc droit
						if(dy == 0 && dx != 0)
						{
							pc = new TronconDroit(courant.x + dx, courant.y + dy, true);
							this.addChild(pc);
							b = new Bruit(courant.x + dx, courant.y + dy);
							b.visible = false;
							bruits.push(b);
							this.addChild(b);
						}
					
						if(dy != 0 && dx == 0)
						{
							pc = new TronconDroit(courant.x + dx, courant.y + dy, false);
							this.addChild(pc);
							b = new Bruit(courant.x + dx, courant.y + dy);
							b.visible = false;
							bruits.push(b);
							this.addChild(b);
							
						}
					}
				
					courant.x += dx;
					courant.y += dy;
				}
				
				courant = suivant;
				_suivant = mPointControleCopy.pop();
				if (_suivant != null)
					suivant = new Point(_suivant.x, _suivant.y);
			}
			
			////pre tracer le bruit
//			for (var n:int = 0 ; n < mPointControle.length-1; n++) 
//			{
//				var b:Bruit = new Bruit(mPointControle[n].x * 60, mPointControle[n].y * 60);
//				b.height = Math.abs(mPointControle[n].y * 60 - mPointControle[n+1].y * 60);
//				b.width = Math.abs(mPointControle[n].x * 60 - mPointControle[n+1].x * 60);
//				bruits.push(b);
//				b.visible = false;
//				this.addChild(b);
//			}
			//trace(mPointControleCopy);
			//trace(mPointControle);
		}
		
		public function sendPaquet(_paquet:Paquet, _emetteur:Routeur) 
		{
			/* //collision
			trace("paquet recu");
			if (paquet != null) 
			{
				paquet.detruire();
				_paquet.detruire();
				paquet = null;
				trace("collision");
			} 
			else 
			{	*/
			//routeur non connecte au chemin
			if ( (_emetteur != mBegin) && (_emetteur != mEnd) ) 
			{
				trace("Ce paquet ne peut emprunter ce chemin!");
			} 
			else 
			{
				paquets.push(_paquet);
				
				//chemin normal ou inverse?
				//trace(mPointControle.length);
				var parcour:Array = copy(mPointControle);
				//trace(parcours.length);
						
				if (_emetteur != mBegin)
					parcour.reverse();
				//trace(parcour);
				parcours.push(parcour);
				emetteurs.push(_emetteur);
				var p:Point = parcour.shift();
				_paquet.x = 15 + p.x * 60;
				_paquet.y = 15 + p.y * 60;
				xSuivs.push( p.x * 60 );
				ySuivs.push( p.y * 60 );
				//trace("pos paquet :" + _paquet.x + " " + _paquet.y);
				stage.addChild(_paquet);
			}
		}
		
		public function movePaquets():int
		{
			var decTTL:int = 0;
			//pour chaque paquet
			for(var i:int = 0; i < paquets.length; i++)
			{
				var paquet:Paquet = paquets[i];
				if (bruit)
					paquet.bruiter(0.2);
				var xSuiv:int = xSuivs[i];
				var ySuiv:int = ySuivs[i];
				var parcour:Array = parcours[i];
				if ( (paquet != null) && ( (paquet.x-15 != xSuiv) || (paquet.y-15 != ySuiv) || ( parcour.length != 0 ) ) )
				{
	
					//trace("deplacement");
					//si le point suivant n'est pas atteint, se deplacer vers lui
					if (paquet.x-15 != xSuiv) {
						if (paquet.x-15 < xSuiv)
							paquet.x = Math.min(paquet.x+2, xSuiv+15);
						else
							paquet.x = Math.max(paquet.x-2, xSuiv+15);
					} 
					else
					{
						if (paquet.y-15 != ySuiv) {
							if (paquet.y-15 < ySuiv)
								paquet.y = Math.min(paquet.y+2, ySuiv+15);
							else
								paquet.y = Math.max(paquet.y-2, ySuiv+15);
						}
						else
						{
							//aller chercher le point de controle suivant
							var suivant:Point = parcour.shift();
							xSuivs[i] = (suivant.x)*60;
							ySuivs[i] = (suivant.y)*60;
						}
					}							
				}
				else
				{
					toRemove.push(i);
				}
				//trace("deplacement termine");
			}
			//retirer les paquets arrivés
			toRemove.sort();
			while (toRemove.length > 0)
			{
				//trace("remove arrivé!");
				var iRemove:int = toRemove.pop();
				var paquetArrive:Paquet = paquets[iRemove];
				//trace(emetteurs[iRemove] + mBegin + mEnd);
				if (!(paquetArrive is POther))
				{
					//trace("TTL -1!");
					decTTL = 1;
				}
				if (emetteurs[iRemove] == mBegin)
					decTTL += mEnd.receivePaquet(mSlot2, paquetArrive);
				else
					decTTL += mBegin.receivePaquet(mSlot1, paquetArrive);				
				paquets.splice(iRemove, 1);
				emetteurs.splice(iRemove, 1);
				parcours.splice(iRemove, 1);
				xSuivs.splice(iRemove, 1);
				ySuivs.splice(iRemove, 1);
			}
			
			// gerer les collisions sur les paquets restants
			if(mCollision)
			{
				for(var p1:int = 0; p1 < paquets.length; p1++)
				{
					for(var p2:int = p1 + 1; p2 < paquets.length; p2++)
					{
						if( (Math.abs(paquets[p1].x - paquets[p2].x) < 5) && (Math.abs(paquets[p1].y - paquets[p2].y) < 5) ) {
							//collision
							toRemove.push(p1);
							toRemove.push(p2);
						}
					}
				}
			}
			//retirer les paquets détruits
			toRemove.sort();
			while (toRemove.length > 0)
			{
				//trace("remove collision!");
				var iDetruit:int = toRemove.pop();
				var paquetDetruit:Paquet = paquets[iDetruit];
				if ( !(paquetDetruit is POther))
					decTTL = 1000;
				paquetDetruit.detruire();
				paquets.splice(iDetruit, 1);
				emetteurs.splice(iDetruit, 1);
				parcours.splice(iDetruit, 1);
				xSuivs.splice(iDetruit, 1);
				ySuivs.splice(iDetruit, 1);
			}
			return decTTL;
		}
		
		//fonction de copie d'un tableau...
		public function copy(ACopier:Array):Array
		{
			var copie:Array = new Array();
			for(var i:int = 0; i < (ACopier.length); i++)
				copie.push(ACopier[i]);
				
			//trace(ACopier);
			
			//trace(copie);
			
			return copie;
		}
	
	}
}