﻿package
{
	import flash.display.MovieClip;
	import TypeRouteur;
	import Routeur;
	import R1;
	import R21;
	import R22;
	import R3;
	import R4;

	
	public class Map extends MovieClip
	{
		//une map contient
		
		//des chemins
		var chemins:Array;
		
		//des paquets
		var paquets:Array;
		
		//des routeurs
		var routeurs:Array;
		
		//des PC
		var PCs:Array;
		
		// Et autres
		var otherPoints:Array;
		
		//un point de depart
		var entryPoint:PCUser;
		
		//un point d'arrive
		var finalPoint:PCGoal;
		
		var cpt:int;
		var moduleCpt:int;
		
		var cptTime:int;
		var moduleCptTime:int;
		
		var paquetLivre:Boolean;
		
		//bruit present
		var bruit:int;
		var cptBruit:int;
		var randBruit:int;
		var bruitPredecent:int;
		
		//score de la map
		var score:int;
		var initScore:int;
		
		//TTL
		var TTL:int;
		var initTTL:int;
		
		//time-Out
		var TO:int;
		var initTO:int;
		
		//limite buffer congestion
		var congestion:int;
		var wait:Boolean;
		
		var begin:Boolean;
		
		var mFast:Boolean;
		var mCollision:Boolean;
		
		//constructeur
		//_bruit = 0 => pas de bruit
		//_bruit = n => 2 nouveaux bruits toutes les n images
		public function Map(_score:int, _TTL:int, _TO:int, _bruit:int, _congestion, _collision:Boolean) 
		{
			chemins = new Array();
			paquets = new Array();
			routeurs = new Array();
			PCs = new Array();
			otherPoints = new Array();
			
			cpt = 0;
			initScore = _score;
			initTTL = _TTL;
			initTO = _TO;
			score = initScore;
			TTL = initTTL;
			TO = initTO;
			cptTime = 0;
			bruit = _bruit;
			cptBruit = 0;
			paquetLivre = false;
			bruitPredecent = -1;
			randBruit = -1;
			congestion = _congestion;
			wait = false;
			moduleCpt = 18;
			moduleCptTime = 60;
			begin = false;
			mFast = false;
		
			mCollision = _collision;
		}
		
		//ajouts de données à la map
		
		public function addChemin(routeur_index_debut:int, routeur_index_fin:int, _slot1:int, _slot2:int)
		{
			var ch:Chemin = new Chemin(routeurs[routeur_index_debut], routeurs[routeur_index_fin], mCollision);
			chemins.push(ch);
			this.addChildAt(ch, 0);
			
			routeurs[routeur_index_debut].setChemin(ch, _slot1);
			routeurs[routeur_index_fin].setChemin(ch, _slot2);
			ch.setBeginSlot(_slot1);
			ch.setEndSlot(_slot2);
		}
		
		public function getScore():int
		{
			return score;
		}
		
		public function getTO():int
		{
			return TO;
		}
		
		public function getTTL():int
		{
			return Math.max(0, TTL);
		}
		
		public function addPaquet(pa:Paquet)
		{
			paquets.push(pa);
		}
		
		public function addRouteur(_type:int, _casex:int, _casey:int, _rotCount:int, _grrr:Boolean)
		{
			var ro:Routeur;
			
			switch(_type)
			{
				case 1 :
					entryPoint = new PCUser(_casex, _casey)
					routeurs.push(entryPoint);
					this.addChildAt(entryPoint, 0);
					break;
					
				case 2 :
					finalPoint = new PCGoal(_casex, _casey)
					routeurs.push(finalPoint);
					this.addChildAt(finalPoint, 0);
					break;
					
				case 3 :
					ro = new PCOther(_casex, _casey, _grrr)
					routeurs.push(ro);
					this.addChildAt(ro, 0);
					otherPoints.push(ro);
					break;
					
				case 4 :
					ro = new R21(_casex, _casey, _rotCount, congestion)
					routeurs.push(ro);
					this.addChildAt(ro, 0);
					break;
					
				case 5 :
					ro = new R22(_casex, _casey, _rotCount, congestion)
					routeurs.push(ro);
					this.addChildAt(ro, 0);
					break;
					
				case 6 :
					ro = new R3(_casex, _casey, _rotCount, congestion)
					routeurs.push(ro);
					this.addChildAt(ro, 0);
					break;
					
				case 7 :
					ro = new R4(_casex, _casey, _rotCount, congestion)
					routeurs.push(ro);
					this.addChildAt(ro, 0);
					break;
			};
		}
		
		public function addPC(pc:PC)
		{
			PCs.push(pc);
		}
		
		public function buildPaths()
		{
			var count:int;
			var x:int;
			
			count = chemins.length;
			
			for(x = 0; x < count; ++x)
			{
				chemins[x].buildPath();
			}
		}
		
		public function addPointControle(_chemin:int, _casex:int, _casey:int)
		{
			chemins[_chemin].addPointControle(_casex, _casey);
		}
		
		public function activateLink(_routeur:int, _slot1:int, _slot2:int)
		{
			routeurs[_routeur].activateLink(_slot1, _slot2);
		}
		
		public function movePaquets() 
		{
			if (begin)
			{
				var count:int;
				var x:int;
				
				var decTTL:int = 0;
				
				count = chemins.length;
				
				if (bruit != 0)
				{
					if (cptBruit % bruit == 0)
					{
						if (bruitPredecent != -1)
							chemins[bruitPredecent].setBruit(false);
						if (randBruit != -1)
							chemins[randBruit].setBruit(false);
						randBruit = randRange(0, count-1);
						cptBruit = 0;
						chemins[randBruit].setBruit(true);
						bruitPredecent = randBruit;
						randBruit = randRange(0, count-1);
						chemins[randBruit].setBruit(true);
					}
					cptBruit++;
				}
				
				for(x = 0; x < count; ++x)
				{
					decTTL += chemins[x].movePaquets();
				}
				
				if( TTL != -1)
					TTL = Math.max(0, TTL - decTTL);
				if (decTTL < 1000)
					score = Math.max(0, score - decTTL);
				
				//refresh paquet
				entryPoint.gererPaquet();
				finalPoint.gererPaquet();
				
				cpt++;
				if( cpt % moduleCpt == 0 ) 
				{
					count = routeurs.length;
					cpt = 0;
				
					for(x = 0; x < count; ++x)
					{
						routeurs[x].gererPaquet();
					}
					
					if (! wait)
					{
						var count2:int = otherPoints.length;
						var i2:int;
						
						for(i2 = 0; i2 < count2; ++i2)
						{
							otherPoints[i2].sendPaquet();
						}
					}
					wait = ! wait;
				}
				
				cptTime++;
				if( cptTime % moduleCptTime == 0 ) 
				{
					cptTime = 0;
					if (TO > 0)
					{
						TO -= mFast ? 5 : 1;
					}
					else
					{
						if(TTL == -1)
						{
							//stage.frameRate = 50;
							moduleCpt *= 6;
							moduleCptTime *= 6;
							score = Math.max(0, score - 10);
							mFast = false;
						}
						TO = initTO;
						TTL = initTTL;
						entryPoint.detruirePaquet();
						finalPoint.detruirePaquet();
						finalPoint.resetEtat();
						entryPoint.sendPaquet();
						paquetLivre = false;
						score = Math.max(0, score - 10);
					}
				}
				if (TTL == 0)
				{
					if (finalPoint.termine())
						finalPoint.detruirePaquet();
					else
						entryPoint.detruirePaquet();
						
					mFast = true;
						
					moduleCpt = moduleCpt/6;
					moduleCptTime = moduleCptTime/6;
					//trace(moduleCpt + " " + moduleCptTime);
					//stage.frameRate = 100;
					TTL = -1;
				}
			}
		}
		
		public function OhYeah()
		{
			TTL = initTTL;
			TO = initTO;
			begin = true;
			if(entryPoint != null)
				entryPoint.sendPaquet();

			/*var count:int = otherPoints.length;
			var i:int;
			
			for(i = 0; i < count; ++i)
			{
				otherPoints[i].sendPaquet();
			}*/
		}
		
		public function termine():Boolean
		{
			if (!paquetLivre)
			{
				paquetLivre = finalPoint.termine();
				if (paquetLivre)
				{
					//TO = initTO;
					if(TTL == -1)
					{
						moduleCpt *= 6;
						moduleCptTime *= 6;
						mFast = false;
						//stage.frameRate = 50;
					}
					TTL = initTTL;
					finalPoint.sendPaquet();
				}
				return false;
			}
			else
			{
				if (entryPoint.termine())
				{
					var count2:int = otherPoints.length;
					var i2:int;
					
					for(i2 = 0; i2 < count2; ++i2)
					{
						otherPoints[i2].detruirePaquet();
					}
					return(true);
				}
				else
					return(false);
			}
		}
		
		function randRange(min:Number, max:Number):Number {
    		var randomNum:Number = Math.floor(Math.random() * (max - min + 1)) + min;
    		return randomNum;
		}
	}
}