﻿package
{
	import TypeRouteur;
	import flash.display.MovieClip;
	import Slot;
	
	public class Routeur extends MovieClip
	{
		protected var mType:int;
		public var casex:int;
		public var casey:int;
		protected var mSlots:Array;
		protected var mSlotMatrix:Array;
		protected var mSize:int;
		var pilePaquets:Array;
		var currentSlot:Array;
		var nextSlot:int;
		var congestion:int;
		
		public function Routeur(_type:int, _casex:int, _casey:int, _rotCount:int, _congestion:int)
		{
			mSlotMatrix = new Array(
				[0,0,0,0],
				[0,0,0,0],
				[0,0,0,0],
				[0,0,0,0]);
			
			mSlots = new Array();
			mSlots.push(new Slot(this, 3, 0, 30, 0));
			mSlots.push(new Slot(this, 0, 30, 0, 1));
			mSlots.push(new Slot(this, 1, 60, 30, 2));
			mSlots.push(new Slot(this, 2, 30, 60, 3));
			
			mSlots[0].visible = false;
			mSlots[1].visible = false;
			mSlots[2].visible = false;
			mSlots[3].visible = false;
			
			x = _casex * 60;
			y = _casey * 60;
			mType = _type;
			casex = _casex;
			casey = _casey;
			
			rotation = _rotCount * 90;
			if(_rotCount == 1)
			{
				x += 60;
			}
			
			if(_rotCount == 2)
			{
				x += 60;
				y += 60;
			}
			
			if(_rotCount == 3)
			{
				y += 60;
			}
			pilePaquets = new Array();
			currentSlot = new Array();
			nextSlot = -1;
			congestion = _congestion;
		}
		
		public function setChemin(_chemin:Chemin, _slot:int)
		{
			mSlots[_slot].chemin = _chemin;
		}
		
		public function activateLink( _slot1:int, _slot2:int)
		{
			mSlotMatrix[_slot1][_slot2] = 1;
			mSlots[_slot2].visible = true;
		}
		
		public function receivePaquet(slot:int ,p:Paquet):int
		{
			//trace("paquet recu par " + this);
			//trace("congestion : " + congestion + " actuelle : " + pilePaquets.length);
			if (pilePaquets.length < congestion)
			{
				if (pilePaquets.length > 0)
					p.visible = false;
				pilePaquets.push(p);
				currentSlot.push(slot);
				
				if( (p.visible) && !(p is POther))
				{
					for(var i:int = 0; i < 4; ++i)
						if(mSlotMatrix[slot][i]) mSlots[i].gotoAndStop(2);
				}
				return 0;
			}
			else
			{
				p.detruire();
				//trace("destruction congestion!");
				if (! (p is POther))
					return 1000;
				else
					return 0
			}
		}
		
		public function gererPaquet()
		{
			//recuperer le paquet le plus vieux dans la liste et l'aiguiller sur un chemin
			var p:Paquet = pilePaquets.shift();
			//trace(p);
			var s1:int = currentSlot.shift();
			//var decTTL:int = 0;
			if( p != null)
			{	//si c'est un paquet user, regarder si le prochain coup est défini
				if ( !(p.estDetruit()))
				{
					if (!(p is POther))
					{
						//si le prochain déplacement est prévu et que le chemin est autorise
						if ((nextSlot != -1) && (mSlotMatrix[s1][nextSlot] == 1))
						{
							//trace("paquet user envoyé");
							//envoyer le paquet
							var ch:Chemin = mSlots[nextSlot].chemin;
							//trace("chemin choisi : " + s1 + "," + nextSlot);
							//trace(mSlotMatrix);
							if (ch == null)
								trace("erreur de construction tracé");
							else
							{
								mSlots[nextSlot].chemin.sendPaquet(p, this)
								if(pilePaquets.length > 0)
									pilePaquets[0].visible = true;
								nextSlot = -1;
								//decTTL = 1;
							}
						}
						else
						{
							//trace("paquet user non envoyé, suivant");
							pilePaquets.push(p);
							currentSlot.push(s1);
							p.visible = false;
							pilePaquets[0].visible = true;
							nextSlot = -1;
						}
					}
					else
					{
						//le deplacer random
						//trace("paquet rand en cours");
						nextSlot = randRange(0,3);
						//var cpt:int = 0;
						//while ( /*(cpt++ < 10000) &&*/ (mSlotMatrix[s1][nextSlot] != 1) )
//							nextSlot = randRange(0,3);
						
						//if(cpt == 10000)
							//trace("rand foireu");
						//else
//							trace("paquet rand envoyé");
							
						//trace("chemin choisi : " + s1 + "," + nextSlot);
//						trace(mSlotMatrix);
						
						//envoyer le paquet
						if (mSlotMatrix[s1][nextSlot] != 1)
						//if (c == null)
						{
							var c:Chemin = mSlots[nextSlot].chemin;
							//if (c == null)
							pilePaquets.push(p);
							currentSlot.push(s1);
							p.visible = false;
							pilePaquets[0].visible = true;
							nextSlot = -1;
						}
						else
						{
							mSlots[nextSlot].chemin.sendPaquet(p, this)
							if(pilePaquets.length > 0)
								pilePaquets[0].visible = true;
							nextSlot = -1;
						}
					}
					
					for(var j:int = 0; j < 4; ++j)
							mSlots[j].gotoAndStop(1);
					
					if ( (pilePaquets[0] != null) && !(pilePaquets[0] is POther) )
					{
						for(var i:int = 0; i < 4; ++i)
							if(mSlotMatrix[currentSlot[0]][i]) mSlots[i].gotoAndStop(2);
					}
				}
				else
					for(var ij:int = 0; ij < 4; ++ij)
							mSlots[ij].gotoAndStop(1);
			}
			//return decTTL;
		}
		
		public function setNextSlotByClick(id:int) {
			if ((pilePaquets.length > 0) && !(pilePaquets[0] is POther))
				nextSlot = id;
			//trace(nextSlot);
			var ch:Chemin =  mSlots[id].chemin;
			//trace(ch.mSlot1 + " " + ch.mSlot2);
		}
		
		function randRange(min:Number, max:Number):Number {
    		var randomNum:Number = Math.floor(Math.random() * (max - min + 1)) + min;
    		return randomNum;
		}
		
	}
}